/*********************************************************************
 *
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2010, Robert Bosch LLC.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Robert Bosch nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 *
 *********************************************************************/

ros.visualization.Markers.CubeMarker = ros.visualization.Markers.Marker.extend({
  init: function(vm) 
  {
    this._super(vm);
    this.model = null;
  },
 
  updateFromMessage: function(marker_msg) 
  {
    this._super(marker_msg);
    this.setFrame(marker_msg.header.frame_id);
    
    this.model = new ros.visualization.BoxModel(this.vm.gl, this.vm.shader_manager);  
    
    if (marker_msg.scale.x * marker_msg.scale.y * marker_msg.scale.z == 0.0)
    {
      ros_debug("Scale of 0 in one of x/y/z");
    }
    this.setPose(marker_msg.pose);
    this.setScale([marker_msg.scale.x,marker_msg.scale.y,marker_msg.scale.z]);
    
    if(marker_msg.color.a == 0)
      marker_msg.color.a = 0.3; 

    this.model.setColor([marker_msg.color.r, marker_msg.color.g, marker_msg.color.b, marker_msg.color.a]);
//    this.model.setColor([marker_msg.color.r, marker_msg.color.g, marker_msg.color.b]);
    
  },
  
});


   
